package cn.iocoder.yudao.module.bpm.dal.mysql.oa;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.MPJLambdaWrapperX;
import cn.iocoder.yudao.module.bpm.api.oa.vo.receipt.ReceiptStatisticsDTO;
import cn.iocoder.yudao.module.bpm.controller.admin.oa.vo.receipt.BpmOAReceiptPageReqVO;
import cn.iocoder.yudao.module.bpm.controller.admin.oa.vo.receipt.BpmOAReceiptRespVO;
import cn.iocoder.yudao.module.bpm.controller.admin.oa.vo.receipt.ReceiptStatisticsVO;
import cn.iocoder.yudao.module.bpm.dal.dataobject.oa.BpmOAContractDO;
import cn.iocoder.yudao.module.bpm.dal.dataobject.oa.BpmOAReceiptDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Objects;

@Mapper
public interface BpmOAReceiptMapper extends BaseMapperX<BpmOAReceiptDO> {
    default PageResult<BpmOAReceiptRespVO> selectReceiptPage(BpmOAReceiptPageReqVO pageReqVO, Long userId) {

        MPJLambdaWrapperX<BpmOAReceiptDO> query = new MPJLambdaWrapperX<>();
        query.selectAll(BpmOAReceiptDO.class);
        query.selectAs(BpmOAContractDO::getContractName, BpmOAReceiptRespVO::getContractName);
        query.selectAs(BpmOAContractDO::getCustomerName, BpmOAReceiptRespVO::getCustomerName);
        query.selectAs(BpmOAContractDO::getContractNo, BpmOAReceiptRespVO::getContractNo);
        query.selectAs("u.nickname", BpmOAReceiptRespVO::getCreateName);
        query.leftJoin(BpmOAContractDO.class, "c", BpmOAContractDO::getId, BpmOAReceiptDO::getContractId);
        query.leftJoin("system_users u on u.id = t.creator");
        query.eqIfPresent(BpmOAReceiptDO::getResult, pageReqVO.getResult());
        query.apply(Objects.nonNull(pageReqVO.getCustomerName()), "c.customer_name LIKE CONCAT('%', {0}, '%')", pageReqVO.getCustomerName());
        query.apply(Objects.nonNull(pageReqVO.getContractName()), "c.contract_name LIKE CONCAT('%', {0}, '%')", pageReqVO.getContractName());
        query.apply(Objects.nonNull(pageReqVO.getCreateName()),"u.nickname Like CONCAT('%', {0}, '%')", pageReqVO.getCreateName());
        if ("my".equals(pageReqVO.getRelation())) {
            query.eq(BpmOAContractDO::getUserId, userId);
        }else if ("sub".equals(pageReqVO.getRelation())){
            query.innerJoin("(" +
                    "\tSELECT DISTINCT\n" +
                    "\t\tu.id \n" +
                    "\tFROM\n" +
                    "\t\tsystem_users u\n" +
                    "\t\tINNER JOIN system_dept d ON d.leader_user_id = "+ userId +"\n" +
                    "\t\tINNER JOIN system_dept d1 ON d1.flag LIKE CONCAT( '%', d.id, '-' ) \n" +
                    "\t\tOR d1.flag LIKE CONCAT( '%-', d.id, '-%' ) \n" +
                    "\t\tOR d1.flag LIKE CONCAT( '-', d.id, '%' ) \n" +
                    "\tWHERE\n" +
                    "\t\tu.dept_id = d1.id \n" +
                    "\t\tAND u.STATUS = 0 \n" +
                    "\t) subordinate ON subordinate.id = t.user_id");
        }
        query.orderByDesc(BpmOAReceiptDO::getCreateTime);

        return selectJoinPage(pageReqVO, BpmOAReceiptRespVO.class, query);
    }

    ReceiptStatisticsVO selectStatistics(@Param("userId") Long userId,
                                         @Param("relation") String relation);

    List<ReceiptStatisticsDTO> selectReceiptStatisticsListByUserIds(@Param("userIds") List<Long> userIds,
                                                                    @Param("createTime") LocalDateTime[] createTime);
}
