package cn.iocoder.yudao.module.bpm.service.oa;

import cn.iocoder.yudao.module.bpm.controller.admin.oa.vo.expenses.BpmOAExpensesCreateReqVO;
import cn.iocoder.yudao.module.bpm.controller.admin.oa.vo.expenses.BpmOAExpensesRespVO;
import cn.iocoder.yudao.module.bpm.dal.dataobject.oa.BpmOAExpensesDO;
import cn.iocoder.yudao.module.bpm.dal.dataobject.oa.BpmOAExpensesItemDO;

import javax.validation.Valid;
import java.util.List;

public interface BpmOAExpensesService {

    /**
     * 创建生产开支申请
     *
     * @param userId      用户编号
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createExpenses(Long userId, @Valid BpmOAExpensesCreateReqVO createReqVO);

    /**
     * 更新生产开支申请的状态
     *
     * @param id     编号
     * @param result 结果
     */
    void updateExpensesResult(String processInstanceId, Long id, Integer result);

    /**
     * 获得生产开支申请
     *
     * @param id 编号
     * @return 现金支出申请
     */
    BpmOAExpensesDO getExpenses(Long id);

    /**
     * 获得指定得生产开支明细
     *
     * @param expensesId 生产开支 编号
     * @return 明细
     */
    List<BpmOAExpensesItemDO> getExpensesItem(Long expensesId);

    /**
     * 通过流程实例id获取
     *
     * @param processInstanceId 流程实例编号
     * @return 生产开支对象
     */
    BpmOAExpensesDO getByProcessInstanceId(String processInstanceId);

    /**
     * 转换生产开支详情  用于前端返回值
     * @param expenses 开支对象
     * @return 开支对象
     */
    BpmOAExpensesRespVO convertExpenses(BpmOAExpensesDO expenses);
}
