package cn.iocoder.yudao.module.bpm.service.oa;

import cn.iocoder.yudao.module.bpm.controller.admin.oa.vo.loan.BpmOALoanCreateReqVO;
import cn.iocoder.yudao.module.bpm.dal.dataobject.oa.BpmOALoanDO;

import javax.validation.Valid;
import java.util.List;

/**
 * 生产借支 Service 接口
 *
 * @author 符溶馨
 */
public interface BpmOALoanService {

    /**
     * 创建借支申请
     *
     * @param userId      用户编号
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createLoan(Long userId, @Valid BpmOALoanCreateReqVO createReqVO);

    /**
     * 更新借支申请的状态
     *
     * @param processInstanceId 流程实例编号
     * @param id                   id
     * @param result               结果
     */
    void updateLoanResult(String processInstanceId, Long id, Integer result);

    /**
     * 获得借支申请
     *
     * @param id 编号
     * @return 加班申请
     */
    BpmOALoanDO getLoan(Long id);

    /**
     * 获得指定的借支申请
     *
     * @param processInstanceId 流程实例编号
     * @return 借支申请
     */
    BpmOALoanDO getByProcessInstanceId(String processInstanceId);

    /**
     * 获得指定用户的借支列表
     * @param staffId 员工编号
     * @return 借支列表
     */
    List<BpmOALoanDO> getListByStaffId(Long staffId);
}
