package cn.iocoder.yudao.module.system.api.loan;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.module.system.api.loan.dto.LoanDTO;
import cn.iocoder.yudao.module.system.enums.ApiConstants;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

@FeignClient(name = ApiConstants.NAME) // TODO 芋艿：fallbackFactory =
@Tag(name = "RPC 服务 - 假期")
public interface LoanApi {

    String PREFIX = ApiConstants.PREFIX + "/loan";

    @PostMapping(PREFIX + "/create")
    @Operation(summary = "创建借支记录")
    CommonResult<Boolean> createLoan(@RequestBody LoanDTO dto);

    @GetMapping(PREFIX + "/getByUserId")
    @Operation(summary = "获取借支记录")
    @Parameter(name = "userId", description = "用户编号", required = true)
    CommonResult<LoanDTO> getByUserId(@RequestParam("userId") Long userId);
}
