package cn.iocoder.yudao.module.system.api.loan;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.system.api.loan.dto.LoanDTO;
import cn.iocoder.yudao.module.system.controller.admin.loan.vo.LoanSaveReqVO;
import cn.iocoder.yudao.module.system.dal.dataobject.loan.LoanDO;
import cn.iocoder.yudao.module.system.service.loan.LoanService;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

@RestController // 提供 RESTful API 接口，给 Feign 调用
@Validated
public class LoanApiImpl implements LoanApi {

    @Resource
    private LoanService loanService;

    @Override
    public CommonResult<Boolean> createLoan(LoanDTO dto) {
        LoanSaveReqVO createDO = BeanUtils.toBean(dto, LoanSaveReqVO.class);
        loanService.createLoan(createDO);
        return success(true);
    }

    @Override
    public CommonResult<LoanDTO> getByUserId(Long userId) {
        LoanDO loanDO = loanService.getByUserId(userId);
        return success(BeanUtils.toBean(loanDO, LoanDTO.class));
    }
}
